<template>
    <div class="label-create q-py-lg q-pl-md-lg">
        <!-- <div class="row justify-start item-center">
            <div class="col-12 q-ml-md-md font-18 text-black q-mt-xs">
                <q-btn flat no-caps @click="selectCurrentPage('label-home')">
                    <q-icon name="arrow_back" color="black" size="25px" />
                    <span class="font-18 helvetica-neue-medium q-pl-md">
                        {{ $t('button.back') }}
                    </span>
                </q-btn>
            </div>
        </div> -->

        <!-- title & save button -->
        <div class="row justify-center item-center q-py-md">
            <div class="row item-center col-6 font-18 text-black q-mt-xs">
                <q-btn
                    class="
                        q-pr-sm q-pl-lg-md q-pl-md-md q-pl-sm-md q-pl-xs-none
                    "
                    flat
                    no-caps
                    @click="selectCurrentPage('label-home')"
                >
                    <q-icon name="arrow_back" color="black" size="25px" />
                </q-btn>
                <div class="label-title-container helvetica-neue-medium">
                    {{ $t('preference.createLabel') }}
                </div>
            </div>
            <div class="col-6 q-pr-md-xl font-18 text-black q-mt-xs text-right">
                <q-btn
                    no-caps
                    text-color="white"
                    class="button-save"
                    :label="$t('button.save')"
                    @click="saveChanges"
                />
            </div>
        </div>

        <!-- label -->
        <div class="row justify-center item-center">
            <div class="col-md-6 col-12 q-pl-md-xl q-mt-xs justify-center">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('preference.labelName') }}
                    <span class="text-ff0000 font-10" v-if="!state.labelName">
                        {{ $t('form.required') }}
                    </span>
                </p>
                <q-input
                    outlined
                    bottom-slots
                    :dense="dense"
                    v-model="state.labelName"
                    bg-color="blue-2"
                    class="border-radius-20"
                ></q-input>
            </div>
            <div
                class="
                    col-md-6 col-12
                    q-pr-md-xl q-mt-xs q-pl-md-md q-pl-xs-none
                    justify-center
                "
            >
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('preference.labelColor') }}
                </p>

                <div class="row helvetica-neue-medium">
                    <div class="col-lg-2 col-md-3 col-xs-3 col-sm-3">
                        <div
                            class="
                                color-container
                                bg-666B72
                                items-center
                                row
                                justify-center
                                border-radius-10
                            "
                            :style="{
                                backgroundColor: state.selectedColor?.name
                            }"
                        >
                            <q-img
                                src="~assets/images/check.png"
                                width="20px"
                                height="20px"
                            />
                        </div>
                    </div>
                    <div class="col-lg-10 col-md-9 col-xs-9 col-sm-9">
                        <div
                            class="
                                q-ml-md q-mb-sm q-pa-md
                                color-container-mini
                                row
                                border-radius-10
                                pointer
                            "
                            :style="{
                                backgroundColor: color.name
                            }"
                            v-for="(color, index) in state.colors"
                            :key="'color-' + index"
                            @click="selectColor(color)"
                        ></div>
                    </div>
                </div>
            </div>
        </div>

        <!-- icons -->
        <div class="row justify-center item-center q-pt-xl">
            <div class="col-12 q-pl-md-xl">
                <p class="font-16 q-mb-md helvetica-neue-medium">
                    {{ $t('preference.pickIcon') }}
                    <span
                        class="text-ff0000 font-10"
                        v-if="!state.selectedIcon"
                    >
                        {{ $t('form.required') }}
                    </span>
                </p>
            </div>
            <div class="col-12 justify-between q-pl-md-xl">
                <div class="row">
                    <div class="col-12">
                        <div
                            :class="
                                state.selectedIcon == icon.name ? 'active' : ''
                            "
                            class="
                                q-mr-sm q-mb-sm q-pa-md
                                icon-container-mini
                                row
                                border-radius-50
                                pointer
                            "
                            v-for="(icon, index) in state.icons"
                            :key="'icon-' + index"
                            @click="selectIcon(icon.name)"
                        >
                            <q-icon :name="icon.name" size="sm"></q-icon>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script lang="ts">
import { useStore } from 'src/store';
import { defineComponent, ref, reactive } from 'vue';
import { MemberPermission } from 'src/services/enums/MemberPermission';

export default defineComponent({
    name: 'CreateRole',
    setup(props, { emit }) {
        let state = reactive({
            currentPage: 'default',
            loadingState: ref(false),
            toggleValue: {} as any,
            labelName: '',
            selectedIcon: '',
            selectedColor: { name: '' } as any,
            lists: [] as any,
            permissionOrder: '',
            colors: [
                {
                    id: 1,
                    name: '#ffcdd2'
                },
                {
                    id: 2,
                    name: '#ff8a80'
                },
                {
                    id: 3,
                    name: '#e040fb'
                },
                {
                    id: 4,
                    name: '#ea80fc'
                },
                {
                    id: 5,
                    name: '#448aff'
                },
                {
                    id: 6,
                    name: '#82b1ff'
                },
                {
                    id: 7,
                    name: '#1de9b6'
                },
                {
                    id: 8,
                    name: '#69f0ae'
                },
                {
                    id: 9,
                    name: '#ffd600'
                },
                {
                    id: 10,
                    name: '#ffff00'
                },
                {
                    id: 11,
                    name: '#9e9e9e'
                },
                {
                    id: 12,
                    name: '#bdbdbd'
                }
            ],
            icons: [
                {
                    id: 1,
                    name: 'nightlight'
                },
                {
                    id: 2,
                    name: 'people'
                },
                {
                    id: 3,
                    name: 'campaign'
                }
            ]
        });
        const store = useStore();

        const selectCurrentPage = (page: string) => {
            emit('change-page', page);
        };

        const selectColor = (color: any) => {
            state.selectedColor.name = color.name;
        };

        const selectIcon = (name: string) => {
            state.selectedIcon = name;
        };

        const saveChanges = async () => {
            if (store.state.role.permissions.label?.create) {

                if (state.selectedColor?.name === '') {
                    state.selectedColor.name = '#666B72';
                }

                if (state.labelName && state.selectedIcon) {
                    const res = await store.dispatch('label/create', {
                        name: state.labelName,
                        color: state.selectedColor.name,
                        icon: state.selectedIcon
                    });

                    if (res.status == 200) {
                        selectCurrentPage('label-home');
                    }
                }
            }
        };
        return {
            state,
            dense: ref(true),
            saveChanges,
            MemberPermission,
            selectColor,
            selectCurrentPage,
            selectIcon
        };
    }
});
</script>
